# -*- coding: utf-8 -*-
##############################################################################
#
#    fiscalyear_close module for OpenERP, wizard to close fiscal year
#    Copyright (C) 2010 Syleam Info Services (<http://www.Syleam.fr/>) Claude Brulé
#
#    This file is a part of account_fix
#
#    account_fix is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    account_fix is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields, osv
#import mx.DateTime
#from mx.DateTime import RelativeDateTime, DateTime

class account_fiscalyear(osv.osv):
    _inherit = "account.fiscalyear"


    def compute_profit_loss(self, cr, uid, id, context=None):
        """ Caled by wizard to sum 'expense' and 'income' accounts to compute profit and loss result
            @param id : (account.fiscalyear.id) fiscal year id
            @param context : not used
            @return : float
        """
        summ = 0.0
        params_sql = { 'fy_close': str(id),
                        'account_types': str( ('expense','income') )
                    }
        sql_profit_loss_sum = """SELECT sum(debit-credit)
                FROM account_move_line al, account_account ac, account_account_type at
                WHERE period_id in (SELECT id FROM account_period WHERE fiscalyear_id=%(fy_close)s)
                    AND al.state<>'draft' and al.account_id = ac.id and ac.type <> 'view'
                    AND ac.user_type = at.id and at.code in %(account_types)s"""
        cr.execute(sql_profit_loss_sum % params_sql)
        summ = cr.fetchone()[0]
        return summ

account_fiscalyear()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
