##############################################################################
#
#    fiscalyear_close module for OpenERP, wizard to close fiscal year
#    Copyright (C) 2009 CamptoCamp Nicolas BESSI
#    Copyright (C) 2010 EVERLIBRE Eric VERNICHON
#    Copyright (C) 2010 Syleam Info Services (<http://www.Syleam.fr/>)
#                  Claude BRULE <claude.brule@syleam.fr>
#
#    This file is a part of fiscalyear_close
#
#    fiscalyear_close is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    fiscalyear_close is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
import pooler
#import time
from operator import itemgetter


class account_invoice(osv.osv):
    """ overload invoice method because of closing fiscal year
    """

    _inherit = "account.invoice"


    def move_line_id_payment_get(self, cr, uid, ids, *args):
        """ return the ids of the move lines which has the same account than the invoice whose id is in ids.
                Check if move line corresponding to invoice is linked to an opening entry.
                    If so, return opening id instead of 'normal' line id
        """
        res_ids = []
        if not ids: 
            return res_ids
        super_ids  = super(account_invoice, self).move_line_id_payment_get(cr, uid, ids, *args)
        if not super_ids: 
            return res_ids

        # search for opening entries link to found moves
        cr.execute('SELECT origin_link, id FROM account_move_line WHERE origin_link IN %s', (tuple(super_ids), ) )
        ar_sql = cr.fetchall()

        done_super_ids = []
        for t in ar_sql:
            res_ids.append(t[1])
            done_super_ids.append(t[0])
        # if no origin_link found then append super_ids
        for id in super_ids:
            if not id in done_super_ids:
                res_ids.append(id)
        return res_ids


account_invoice()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
