#!/bin/bash
#
# This script use openobject-library to recompute residual and reconciled of invoices
#   You can find openobject-library at http://bazaar.launchpad.net/~openobject-library/openobject-library/5.0/


#Init / help
help_script()
{
    echo "Usage : "
    echo "run-recompute-invoices.sh [openerp_database_name]"
    echo "  You need to have openobject-library installed"
    echo "  You may put path to it in PYTHONPATH"
    exit 1
}

if [ $# -lt 1 ]; then
    help_script
fi


OPENOBJECT_ADMIN_PATH=~/openERP-500/launchpad/lp_openobject-library

PYTHONPATH=$PYTHONPATH:$OPENOBJECT_ADMIN_PATH
export PYTHONPATH
echo "PYTHONPATH = $PYTHONPATH"


# ###############################################@
#   O P E N E R P     P A R A M S
# ###############################################@
SERVER=localhost
PORT=8069

DBNAME=$1
DBUSER=admin
PW=admin

# ###############################################@
#   L O G   F I L E
# ###############################################@

LOG_FILE=$SERVER-$DBNAME.log
echo "LOG_FILE = $LOG_FILE"
date | tee -a $LOG_FILE


# ####################@
#   S T A R T
# ####################@
COMMAND_LINE="./recompute-invoices.py -s $SERVER -p $PORT -d $DBNAME -u $DBUSER -w $PW"
echo "DEBUG: $COMMAND_LINE"

python $COMMAND_LINE | tee -a $LOG_FILE

echo "Fait " | tee -a $LOG_FILE

