#!/usr/bin/env python
# --*- coding: utf-8 -*-
##############################################################################
#   Recompute amount_currency of each account.move.line
#
from oobjlib.connection import Connection
from oobjlib.component import Object

from oobjlib.common import GetParser
from optparse import OptionGroup


# ######################################
#   Connect to OpenERP via XML-RPC
# ######################################
cli_args = GetParser('Test Import XML from XmlRPC Connection', '0.1')

group = OptionGroup(cli_args, 'Import XML', "Application option")

# Supll
#group.add_option('-f', '--filename', dest='filename', help='file name'),
#cli_args.add_option_group(group)

opts, args = cli_args.parse_args()

try:
    cnx = Connection(
        server=opts.server, 
        dbname=opts.dbname, 
        login=opts.user, 
        password=opts.passwd, 
        port=opts.port)
except Exception, e:
    print '%s' % str(e)
    exit(1)



# ######################################
#   M A I N
# ######################################

company_obj = Object(cnx, 'res.company')

company_ids = company_obj.search([])
if len(company_ids) != 1:
    print "ERROR on company"
    exit(1)
#else
ar_company = company_obj.read(company_ids[0])
print "INFO: currency of the company %s is : %s" % (ar_company['name'], ar_company['currency_id'][1])
company_currency_id = ar_company['currency_id'][0]

line_obj = Object(cnx, 'account.move.line')
cur_obj = Object(cnx, 'res.currency')

# Look for line related to invoice
srch_args = [('partner_id','!=',False),('ref','!=',False),('currency_id','!=',False)]
line_ids = line_obj.search(srch_args)
print "INFO: %d lines found" % len(line_ids)

for ar_line in line_obj.read(line_ids, ['debit','credit','currency_id','name']):
#    print "DEBUG: ar_line = %r" % ar_line
    if ar_line.get('currency_id'):
        if ar_line['currency_id'][0] == company_currency_id:
            amount_currency = ar_line.get('debit', 0.0) - ar_line.get('credit', 0.0)
        else:
        # we need to convert currency amount
            cur_debit = cur_obj.compute(ar_line['currency_id'][0], company_currency_id, ar_line.get('debit', 0.0))
            cur_credit = cur_obj.compute(ar_line['currency_id'][0], company_currency_id, ar_line.get('credit', 0.0))
            amount_currency = cur_debit - cur_credit
    # write
#        print "DEBUG: %d : %.2f" % (ar_line['id'], amount_currency)
        try:
            line_obj.write([ar_line['id']], {'amount_currency': amount_currency})
        except Exception, e:
            print "ERROR: (%d) %r" % (ar_line['id'], e)
    else:
    # No currency specified
        print "ERROR: No currency specified = %d" % ar_line['id']

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
